var c = Object.defineProperty;
var l = (o, e, t) => e in o ? c(o, e, { enumerable: !0, configurable: !0, writable: !0, value: t }) : o[e] = t;
var r = (o, e, t) => (l(o, typeof e != "symbol" ? e + "" : e, t), t);
import { Timestamp as s } from "firebase-admin/firestore";
import { ModelConverter as u } from "jrx-ts";
class n extends u {
  constructor() {
    super(...arguments);
    r(this, "isFunctionCompatible", !1);
  }
  /**
   * Converts the specified document snapshot into model T.
   * Returns undefined if the snapshot does not exist.
   */
  fromSnapshot(t) {
    if (t.exists)
      return this.toModel(t.id, t.data());
  }
  /**
   * Converts the specified document snapshot into model T.
   * Returns null if the conversion fails.
   * Returns undefined if the snapshot does not exist.
   */
  fromSnapshotSafe(t) {
    if (t.exists)
      return this.toModelSafe(t.id, t.data()) ?? null;
  }
  /**
   * Converts the specified model into plain object compatible with Function response.
   */
  toPlainForFunction(t) {
    const i = this.isFunctionCompatible;
    this.setFunctionCompatible(!0);
    const a = this.toPlain(t);
    return this.setFunctionCompatible(i), a;
  }
  /**
   * When sending the client response via Firebase Functions, certain values must be of supported types or it'll throw an error.
   * For example, Sending Timestamp via Function response will throw an error.
   * Setting this to true will encode the values to Function compatible types.
   */
  setFunctionCompatible(t) {
    this.isFunctionCompatible = t;
    for (const i of this.subconverters)
      i instanceof n && i.setFunctionCompatible(t);
  }
  encodeDate(t) {
    return this.isFunctionCompatible ? super.encodeDate(t) : this.encodeDateFirestore(t);
  }
  decodeDate(t, i) {
    return t instanceof s ? t.toDate() : super.decodeDate(t, i);
  }
  encodeDateFirestore(t) {
    return s.fromDate(t);
  }
}
class C {
  static isDebugMode() {
    return process.env.FIREBASE_DEBUG_MODE === "true";
  }
}
class F {
  /**
   * Handles CORS-related issue for httpsRequest function.
   * https://stackoverflow.com/questions/57326098/enable-cors-in-firebase-cloud-function
   * 
   * The function should simply retrurn when this function return true.
   */
  static handleCors(e, t) {
    return t.set("Access-Control-Allow-Origin", "*"), t.set("Access-Control-Allow-Methods", "GET, PUT, POST, OPTIONS"), t.set("Access-Control-Allow-Headers", "*"), e.method === "OPTIONS" ? (t.end(), !0) : !1;
  }
}
export {
  n as FirestoreModelConverter,
  C as JrxFirebaseUtils,
  F as JrxHttpsUtils
};
//# sourceMappingURL=index.es.js.map
